﻿using ComPDFKit.PDFDocument;
using Prism.Mvvm;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PDF_Office.Model.BOTA
{
    public class OutlineNode : BindableBase
    {
        /// <summary>
        /// 父类大纲
        /// </summary>
        private OutlineNode parent = null;

        public OutlineNode Parent
        {
            get { return parent; }
            set
            {
                SetProperty(ref parent, value);
            }
        }
        /// <summary>
        /// 当前大纲对象
        /// </summary>
        private CPDFOutline outline = null;

        public CPDFOutline Outline
        {
            get { return outline; }
            set
            {
                SetProperty(ref outline, value);
            }
        }

        /// <summary>
        /// 子类大纲集合
        /// </summary>
        private ObservableCollection<OutlineNode> chlidlist = new ObservableCollection<OutlineNode>();

        public ObservableCollection<OutlineNode> Chlidlist
        {
            get { return chlidlist; }
            set
            {
                SetProperty(ref chlidlist, value);
            }
        }

        /// <summary>
        /// 控制虚线的显示
        /// </summary>
        private bool isInsertNextLayer = false;

        public bool IsInsertNextLayer
        {
            get { return isInsertNextLayer; }
            set
            {
                SetProperty(ref isInsertNextLayer, value);
            }
        }

        /// <summary>
        /// 控制实线的显示
        /// </summary>
        private bool isInsertCurrentLayer = false;

        public bool IsInsertCurrentLayer
        {
            get { return isInsertCurrentLayer; }
            set
            {
                SetProperty(ref isInsertCurrentLayer, value);
            }
        }

    }
}
