﻿using ComPDFKit.PDFDocument;
using PDF_Office.Helper;
using PDF_Office.Model.BOTA;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace PDF_Office.Views.BOTA
{
    /// <summary>
    /// OutLineControl.xaml 的交互逻辑
    /// </summary>
    public partial class OutLineControl : UserControl
    {
        public OutLineControl()
        {
            InitializeComponent();
        }

        private void BtnMore_Click(object sender, RoutedEventArgs e)
        {
            MenuMore.Placement = System.Windows.Controls.Primitives.PlacementMode.Bottom;
            MenuMore.PlacementTarget = BtnMore;
            MenuMore.IsOpen = true;
        }
        private void OutlineView_PreviewMouseMove(object sender, MouseEventArgs e)
        {
            if (e.LeftButton == MouseButtonState.Pressed )
            {
                var pos = e.GetPosition(OutlineView);
                HitTestResult result = VisualTreeHelper.HitTest(OutlineView, pos);
                if (result == null)
                {
                    return;
                }
                var treeViewItem = CommonHelper.FindVisualParent<TreeViewItem>(result.VisualHit);
                if (treeViewItem == null)
                {
                    return;
                }
                DataObject dataObj = new DataObject(treeViewItem);
                DragDrop.DoDragDrop(OutlineView, dataObj, DragDropEffects.Move);
                return;
            }
        }

        private TreeViewItem Treeviewitem = null;
        private void Grid_DragOver(object sender, DragEventArgs e)
        {
            TreeViewItem sourceitem = e.Data.GetData(typeof(TreeViewItem)) as TreeViewItem;
            if (sourceitem == null)
            {
                return;
            }
            Point pos = e.GetPosition(OutlineView);
            HitTestResult result = VisualTreeHelper.HitTest(OutlineView, pos);
            if (result != null)
            {
                TreeViewItem treeviewitem = CommonHelper.FindVisualParent<TreeViewItem>(result.VisualHit);
                if (treeviewitem != null)
                {
                    Point p = treeviewitem.TranslatePoint(new Point(0, 0), OutlineView);
                    if (Treeviewitem==null)
                    {
                        Treeviewitem = treeviewitem;
                    }
                    else if (!Treeviewitem.Equals(treeviewitem))
                    {
                        (Treeviewitem.DataContext as OutlineNode).IsInsertCurrentLayer = false;
                        (Treeviewitem.DataContext as OutlineNode).IsInsertNextLayer = false;
                        Treeviewitem = treeviewitem;
                    }
                    else
                    {
                        (Treeviewitem.DataContext as OutlineNode).IsInsertCurrentLayer = false;
                        (Treeviewitem.DataContext as OutlineNode).IsInsertNextLayer = false;
                    }
                    if (pos.Y < p.Y + 16)
                    {
                        (treeviewitem.DataContext as OutlineNode).IsInsertCurrentLayer = true;
                    }
                    else
                    {
                        (treeviewitem.DataContext as OutlineNode).IsInsertNextLayer = true;
                    }
                }

            }

        }
    }
}
